-- Schema: C6Mart
-- Stored Procedure: RP_DM_GestioneEmailNOPRO


--select * from c6mart.gestione_Email where data_Generazione > getDate()-1 and tipo like '%pro%'
-- =============================================
-- Author:		<Valerio,,Name>
-- Create date: <19/14/2011,,> -1 ai -2!
-- Description:	<Popola la tabella email con i clienti con profilo scaduto>
-- =============================================
CREATE procedure [C6Mart].[RP_DM_GestioneEmailNOPRO]
AS
BEGIN

BEGIN TRANSACTION	

DECLARE @NUMGIORNIDALPERF SMALLINT
DECLARE @NUMGIORNIDASOLLECITO SMALLINT
DECLARE @MaxInvioSoll SMALLINT
DECLARE @ID_ELAB INT

SET @NUMGIORNIDALPERF = CAST(dbo.getParametro('NUMGIORNIDALPERF') as smallint)
SET @NUMGIORNIDASOLLECITO = CAST(dbo.getParametro('NUMGIORNIDASOLLECITO') AS SMALLINT) --7
SET @MaxInvioSoll = CAST(dbo.getParametro('MaxInvioSoll') AS SMALLINT)
SET @ID_ELAB = C6MART.GETIDELAB()

-- Log esecuzione
INSERT INTO LOG_ESECUZIONE
	(Nome, Inizio, Nota)
VALUES (
	'RP_DM_GestioneEmailNOPRO',
	GETDATE(),
	'Elaborazione giornaliera'
)

-- 1. INSERIMENTO MAIL "SOLLECITI"
	-- TUPLE DA PERFEZIONARE SU CONTRATTOSEI
	-- E PRESENTI SU GESTIONE_EMAIL
	-- IL PB NON HA ATTIVATO UN PROFILO VALIDO AL CLIENTE
	-- N.B. PER IL PRIMO SOLLECITO DATA_ULTIMOSOLLECITO è NULL -> CONSIDERIAMO DATA_PERF
		
	INSERT INTO C6Mart.GESTIONE_EMAIL
		(Rete,Cod_Fiscale,Tipo,Data_Generazione,ID_ELAB)
	SELECT 
		VC.rete,
		VC.cod_fiscale,
		CASE 
			WHEN ISNULL(MD.numSolleciti,0) = 0 THEN '1_SOLL_NOPRO'
			WHEN MD.numSolleciti = 1 THEN '2_SOLL_NOPRO'
			WHEN MD.numSolleciti = 2 THEN '3_SOLL_NOPRO'
			ELSE 'S_SOLL_NOPRO'
		END as tipoEmail,
		getDate() as DataGenerazione,
		@ID_ELAB AS ID_ELAB
	FROM C6Mart.vcontratti VC
		INNER JOIN [C6Mart].[CONTRATTOSEI_METADATI] MD
			ON MD.chiaveclientepb = VC.chiaveclientepb
	LEFT JOIN C6MART.CODICI_PROMOTORI_FITTIZI PF
		ON VC.COD_AGENTE BETWEEN PF.CODICEDA AND PF.CODICEA
		AND VC.RETE = PF.RETE
	WHERE 1 = 1
		AND MD.numSolleciti < @MaxInvioSoll
		AND (
				(ISNULL(MD.numSolleciti,0) = 0 AND DATEDIFF(DAY,VC.Data_Perf,GETDATE()) >= @NUMGIORNIDALPERF)
				 OR
				(DATEDIFF(DAY,isnull(MD.Data_UltimoSollecito,GETDATE()),GETDATE()) >= @NUMGIORNIDASOLLECITO)
			)	
		AND MD.clienteMigrato = 'S' 
		AND MD.risorseNA = 'N'
		AND MD.profiloAttivo = 0
		AND VC.Data_FineAvanzato > getDate()
		--AND VC.GenerazioneReport = 'S'
		AND PF.RETE IS NULL
		and vc.TIP_CONTRATTO<>3

		union 

			SELECT 
		VC.rete,
		VC.cod_fiscale,
		CASE 
			WHEN ISNULL(MD.numSolleciti,0) = 0 THEN '1_SOLL_NOPRO_DA'
			WHEN MD.numSolleciti = 1 THEN '2_SOLL_NOPRO_DA'
			WHEN MD.numSolleciti = 2 THEN '3_SOLL_NOPRO_DA'
			ELSE 'S_SOLL_NOPRO_DA'
		END as tipoEmail,
		getDate() as DataGenerazione,
		@ID_ELAB AS ID_ELAB
	FROM C6Mart.vcontratti VC
		INNER JOIN [C6Mart].[CONTRATTOSEI_METADATI] MD
			ON MD.chiaveclientepb = VC.chiaveclientepb
	LEFT JOIN C6MART.CODICI_PROMOTORI_FITTIZI PF
		ON VC.COD_AGENTE BETWEEN PF.CODICEDA AND PF.CODICEA
		AND VC.RETE = PF.RETE
	WHERE 1 = 1
		AND MD.numSolleciti < @MaxInvioSoll
		AND (
				(ISNULL(MD.numSolleciti,0) = 0 AND DATEDIFF(DAY,VC.Data_Perf,GETDATE()) >= @NUMGIORNIDALPERF)
				 OR
				(DATEDIFF(DAY,isnull(MD.Data_UltimoSollecito,GETDATE()),GETDATE()) >= @NUMGIORNIDASOLLECITO)
			)	
		AND MD.clienteMigrato = 'S' 
		AND MD.risorseNA = 'N'
		AND MD.profiloAttivo = 0
		AND VC.Data_FineAvanzato > getDate()
		--AND VC.GenerazioneReport = 'S'
		AND PF.RETE IS NULL
		and vc.TIP_CONTRATTO=3
		
	-- Log esecuzione
	UPDATE
		LOG_ESECUZIONE
	SET
		Fine = GETDATE(),
		Tipo = 'INSERT',
		Righe = @@ROWCOUNT
	WHERE
		Nome = 'RP_DM_GestioneEmailNOPRO' AND
		Inizio = (
			SELECT
				MAX(Inizio)
			FROM
				LOG_ESECUZIONE
			WHERE
				Nome = 'RP_DM_GestioneEmailNOPRO'
		)

	INSERT INTO LOG_ESECUZIONE
		(Nome, Inizio, Nota)
	VALUES (
		'RP_DM_GestioneEmailNOPRO',
		GETDATE(),
		'Elaborazione giornaliera'
	)

-- 1.BIS UPDATE CONTRATTOSEI DOPO INSERIMENTO MAIL "SOLLECITI"
	-- AUMENTIAMO IL N
